#ifndef __SCRAPCOLOR_HEADER__
#define __SCRAPCOLOR_HEADER__

// scrapcolor.h
//
// Public types and functions for the scrap color format.
// Version 1.0
// Written by Mark Womack, June 1996.
//
// The code and clipboard format are placed in the public domain
// for the benefit of all. It is hoped that it will become a
// standard used by many applications, commercial and shareware,
// to transfer color information effectively.
//
// The author takes no responsibility damages rendered caused by bugs
// or defects lurking in this code. If you find a bug, please use the
// email address in the accompnaying read me file to contact him.

// public types
//
typedef struct {
	SmallFract	value1;
	SmallFract	value2;
	SmallFract	value3;
}ColorData;

// public defines
//
#define	kRGBModel	0
#define	kHSLModel	1
#define	kHSVModel	2
#define	kCMYModel	3

// public functions
//
// get color from scrap in model it is
extern pascal OSErr GetColorFromScrap(ColorData* colorData, short* colorModel);

// get color from scrap in the RGB model
extern pascal OSErr GetRGBColorFromScrap(RGBColor* theColor);

// get color from scrap in the HSL model
extern pascal OSErr GetHSLColorFromScrap(HSLColor* theColor);

// get color from scrap in the HSV model
extern pascal OSErr GetHSVColorFromScrap(HSVColor* theColor);

// get color from scrap in the CMY model
extern pascal OSErr GetCMYColorFromScrap(CMYColor* theColor);

// put color into scrap in given color model (no conversion)
extern pascal OSErr PutColorIntoScrap(const ColorData* colorData, const short colorModel);

// put an RGB color into the scrap
extern pascal OSErr PutRGBColorIntoScrap(const RGBColor* theColor);

// put an HSL color into the scrap
extern pascal OSErr PutHSLColorIntoScrap(const HSLColor* theColor);

// put an HSV color into the scrap
extern pascal OSErr PutHSVColorIntoScrap(const HSVColor* theColor);

// put an CMY color into the scrap
extern pascal OSErr PutCMYColorIntoScrap(const CMYColor* theColor);

// convert from one color model to another
extern pascal OSErr ConvertColor(const ColorData* oldColor, const short oldModel, ColorData* newColor, const short newModel);

#endif